/* Quick probabilistic primality testing.
   Useful e.g. for picking hash table sizes. 
   It's up to the caller to seed the random number generator (using seed48()). */

#ifndef _PRIME_H
#define _PRIME_H

#include <sys/types.h>   /* defines ulong as unsigned long; we could do that ourselves,
			    but then sometimes get a duplicate defs error */
#include "bool.h"

ulong uliNearbyPrime(ulong uli);
bool fPrimeMillerRabin(ulong n, int iChecks);

#endif /* _PRIME_H */
