/* st: A simple stack of pointers that doubles or halves in size as necessary. 
   Low overhead, not much flexibility. 

   May also be used as a random access vector.
   Caller is free to do random access through the ap field, e.g., st->ap[i].
   Often this feature makes it useful to use stacks even without pop. */

#ifndef _STACK_H
#define _STACK_H

typedef struct _stack {      /* st: stack */
  void **ap;   /* array of pointers -- caller is allowed to access this */
  int cp;      /* current occupancy of array */
  int cpMax;   /* current capacity of array */
} *stack;

stack stNew(unsigned int cp);       
void FreeStack(stack st);

void PushStack(stack st, void *p);
void *pPopStack(stack st);
int iStackEntries(stack st);
void ClearStackNoResize(stack st);

/* could do iterators in both directions */

#endif /* _STACK_H */
